// BATTLE SKIN PANIC (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

bool dcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	unsigned char *ptr = buff;
	int trk = _trk;
	// O2gbNǂ AZN^5̍Ō0x10bytê͎Ă (N=3Œ)
	disk.ReadDATA(trk, trk>>1, trk&1, 1, 3, ptr, 0x400*5-0x10);
	ptr += 0x400*5-0x10;
	trk++;
	disk.ReadDATA(trk, trk>>1, trk&1, 1, 3, ptr, 0x400*5-0x10);
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + (_R-1)*0x400 + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;

	struct fpos md1[] =
	{
		{ 0x34, 0x01, 0x0200, 0x05a0 }, // 00
		{ 0x34, 0x02, 0x03a0, 0x0310 }, // 01
		{ 0x34, 0x03, 0x02b0, 0x0460 }, // 02
		{ 0x34, 0x04, 0x0310, 0x018c }, // 03
		{ 0x34, 0x05, 0x009c, 0x0200 }, // 04
		{ 0x34, 0x05, 0x029c, 0x0920 }, // 05 ݊܂
		{ 0x35, 0x02, 0x03cc, 0x03a0 }, // 06
		{ 0x35, 0x03, 0x036c, 0x05f0 }, // 07
		{ 0x35, 0x05, 0x015c, 0x0320 }, // 08
		{ 0x36, 0x01, 0x007c, 0x03f0 }, // 09
		{ 0x36, 0x02, 0x006c, 0x0330 }, // 10
		{ 0x36, 0x02, 0x039c, 0x0500 }, // 11
		{ 0x36, 0x04, 0x009c, 0x0300 }, // 12
		{ 0x36, 0x04, 0x039c, 0x0390 }, // 13
		{ 0x36, 0x05, 0x032c, 0x0350 }, // 14 ݊܂
		{ 0x37, 0x01, 0x028c, 0x0210 }, // 15
		{ 0x37, 0x02, 0x009c, 0x052c }, // 16
		{ 0x37, 0x03, 0x01a8, 0x04a0 }, // 17
		{ 0x37, 0x04, 0x0248, 0x05e0 }, // 18 ݊܂
		{ 0x38, 0x01, 0x0038, 0x0480 }, // 19
		{ 0x38, 0x02, 0x00b8, 0x0110 }, // 20
		{ 0x38, 0x02, 0x01c8, 0x012c }, // 21
		{ 0x38, 0x02, 0x02f4, 0x00e0 }, // 22
		{ 0x38, 0x02, 0x03d4, 0x00e0 }, // 23
		{ 0x38, 0x03, 0x00b4, 0x00e0 }, // 24
		{ 0x38, 0x03, 0x0194, 0x0100 }, // 25
		{ 0x38, 0x03, 0x0294, 0x00f0 }, // 26
		{ 0x38, 0x03, 0x0384, 0x0300 }, // 27
		{ 0x38, 0x04, 0x0284, 0x0240 }, // 28
		{ 0x38, 0x05, 0x00c4, 0x0220 }, // 29
		{ 0x00, 0x00, 0x0000, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x05);
		disk.ReadDATA1(0x01, 0x00, 0x01, 0x01, 0x01, buff, 0x100);
		if (!memcmp(&buff[0x01],"DISK",4))
		{
			switch (buff[0x05])
			{
			case 'A':
				printf("Disk A F܂.\n");
				fcut("DRIVER", 0x02, 0x01, 0x00, 0x01, 0x03, 0x0000, 0x2448);
				for (i=0; md1[i].sec; i++)
				{
					sprintf(fname,"MUS%02d",i);
					dcut(fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x03, md1[i].ofs, md1[i].size);
				}
				continue;

			case 'B':
				printf("Disk B F܂.\n");
				continue;

			case 'C':
				printf("Disk C F܂.\n");
				continue;
			}
		}
	}
	return 0;
}

